--  ________________________________________
--
--  hzFrosty
-- 
--  v1.01 (9 Jan 2007)
--
--  File : hzFrosty.lua
--  ________________________________________
--
--  http://www.horizonsclan.com/
--  ________________________________________
--

hzFrosty = {}
hzFrosty.Version            = "1.01"
hzFrosty.VersionDate        = "9 Jan 2007"
hzFrosty.Info               = {}

hzFrostyDefaults = {}
hzFrostyDefaults.Version = hzFrosty.Version
hzFrostyDefaults.Enabled = true
hzFrostyDefaults.Locked = false
hzFrostyDefaults.ShowLifetime = true
hzFrostyDefaults.ShowCooldown = true
hzFrostyDefaults.ShowFreeze = true
hzFrostyDefaults.ShowWaterbolt = true
hzFrostyDefaults.Stats = {}
hzFrostyDefaults.Stats.LifetimeDamage   = 0
hzFrostyDefaults.Stats.LifetimeCount    = 0
hzFrostyDefaults.Stats.LifetimeDuration = 0
hzFrostyDefaults.Stats.SessionDamage    = 0
hzFrostyDefaults.Stats.SessionCount     = 0
hzFrostyDefaults.Stats.SessionDuration  = 0
hzFrostyDefaults.Stats.CombatDamage     = 0
hzFrostyDefaults.Stats.CombatCount      = 0
hzFrostyDefaults.Stats.CombatDuration   = 0


-------------------------------------------------
--
-- hzFrosty.Print
--
-------------------------------------------------
function hzFrosty.Print( msg )

    DEFAULT_CHAT_FRAME:AddMessage( "|cff0EAEB8"..HZFROSTY_PRINT_NAME..":|r "..msg, 0.9, 0.9, 0.9 )

end


-------------------------------------------------
--
-- hzFrosty.OnLoad
--
-------------------------------------------------
function hzFrosty.OnLoad()

    SlashCmdList["HZFROSTY"] = hzFrosty.SlashHandler
    SLASH_HZFROSTY1 = "/hzfrosty"
    SLASH_HZFROSTY2 = "/frosty"
	    
    this:RegisterEvent("VARIABLES_LOADED")

    local _,class = UnitClass("player")
    if class == "MAGE" then

        this:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
        this:RegisterEvent("UNIT_PET")
        this:RegisterEvent("UNIT_SPELLCAST_START")
       	this:RegisterEvent("UNIT_SPELLCAST_STOP")
	    this:RegisterEvent("UNIT_SPELLCAST_FAILED")
        this:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	    this:RegisterEvent("UNIT_SPELLCAST_DELAYED")

        this:RegisterEvent("CHAT_MSG_SPELL_PET_DAMAGE")

        this:RegisterEvent("PLAYER_REGEN_DISABLED")
        this:RegisterEvent("PLAYER_REGEN_ENABLED")
        hzFrosty.Info.IsMage = true
    end	

end



-------------------------------------------------
--
-- hzFrosty.OnEvent
--
-------------------------------------------------
function hzFrosty.OnEvent()

    if event == "VARIABLES_LOADED" then
        hzFrosty.Print( HZFROSTY_MSG_ADDONLOADED.." (v"..hzFrosty.Version..") - "..hzFrosty.VersionDate )
        if type(hzFrostyData) ~= "table" or hzFrostyData.Version ~= hzFrostyDefaults.Version then 
            hzFrostyData = hzFrostyDefaults
            hzFrosty.Print( "  "..HZFROSTY_MSG_RESETCONFIG )
        end
    end
    
    
    --
    -- SUMMON EVENT
    --
    if event == "UNIT_SPELLCAST_SUCCEEDED" then
        if arg1 == "player" and arg2 == HZFROSTY_SUMMON_SPELL then
            if not hzFrosty.Info.Summoned then
                if hzFrostyData.Enabled and not hzFrostyData.Locked then
                    hzFrosty.Print( HZFROSTY_MSG_MUSTLOCK )
                end
                hzFrosty.Info.SummonedAt = GetTime()
                hzFrosty.Info.Summoned = true
                hzFrosty.Info.Casting = false
                hzFrostyData.Stats.LifetimeCount = hzFrostyData.Stats.LifetimeCount + 1
                hzFrostyData.Stats.SessionCount = hzFrostyData.Stats.SessionCount + 1
                hzFrostyData.Stats.CombatCount = hzFrostyData.Stats.CombatCount + 1
            end
        end

    end

    --
    -- DESUMMON EVENT
    --
    if event == "UNIT_PET" then
        if arg1 == "player" then
            if not UnitExists("pet") or UnitName("pet") ~= HZFROSTY_SUMMON_NAME then
		if GetTime() - hzFrosty.Info.SummonedAt > 1.6 then
                    if hzFrosty.Info.Summoned then
		        hzFrosty.Info.Summoned = false
                        local timeOut = GetTime() - hzFrosty.Info.SummonedAt
                        hzFrostyData.Stats.LifetimeDuration = hzFrostyData.Stats.LifetimeDuration + timeOut
                        hzFrostyData.Stats.SessionDuration = hzFrostyData.Stats.SessionDuration + timeOut
                        hzFrostyData.Stats.CombatDuration = hzFrostyData.Stats.CombatDuration + timeOut
                    end
	        end
    	    end
        end
    end
    
    --
    -- CASTING EVENTS (START)
    --
    --
    if event == "UNIT_SPELLCAST_START" then
        if arg1 == "pet" and hzFrosty.Info.Summoned then
            local spell, rank, displayName, icon, startTime, endTime, isTradeSkill = UnitCastingInfo(arg1)
            if spell == HZFROSTY_SUMMON_CAST then
                hzFrosty.Info.Casting = true
                hzFrosty.Info.CastingFrom = startTime / 1000
                hzFrosty.Info.CastingTo = endTime / 1000
            end
        end
    end

    --
    -- CASTING EVENTS (DELAYED)
    --
    --
    if event == "UNIT_SPELLCAST_DELAYED" then
        if arg1 == "pet" and hzFrosty.Info.Summoned then
            local spell, rank, displayName, icon, startTime, endTime, isTradeSkill = UnitCastingInfo(arg1)
            if spell == HZFROSTY_SUMMON_CAST then
                hzFrosty.Info.Casting = true
                hzFrosty.Info.CastingFrom = startTime / 1000
                hzFrosty.Info.CastingTo = endTime / 1000
            end
        end    
    end
    
    --
    -- CASTING EVENTS (STOPPED)
    --
    --
    if event == "UNIT_SPELLCAST_FAILED" or event == "UNIT_SPELLCAST_STOP" or event == "UNIT_SPELLCAST_INTERRUPTED" then
        if arg1 == "pet" then
            hzFrosty.Info.Casting = false
        end
    end
    
    --
    -- STATS EVENT (SPELL_PET_DAMAGE)
    --
    if event == "CHAT_MSG_SPELL_PET_DAMAGE" then
        local valid, damage = hzFrosty.HandlePetDamageEvent( arg1 )
        if valid then
            hzFrostyData.Stats.LifetimeDamage   = hzFrostyData.Stats.LifetimeDamage + damage
            hzFrostyData.Stats.SessionDamage    = hzFrostyData.Stats.SessionDamage + damage
            hzFrostyData.Stats.CombatDamage     = hzFrostyData.Stats.CombatDamage + damage
        end
    end

    --
    -- STATS EVENT (PLAYER_REGEN_DISABLED)
    --
    if event == "PLAYER_REGEN_DISABLED" then
        if not hzFrosty.Info.OutOfCombat then hzFrosty.Info.OutOfCombat = 0; end
        local timeSinceLast = GetTime() - hzFrosty.Info.OutOfCombat
        -- must of been out of combat for at least 10 seconds to reset
        if timeSinceLast > 10 then
            hzFrostyData.Stats.CombatDamage     = 0
            hzFrostyData.Stats.CombatCount      = 0
            hzFrostyData.Stats.CombatDuration   = 0
        end
    end

    --
    -- STATS EVENT (PLAYER_REGEN_ENABLED)
    --
    if event == "PLAYER_REGEN_ENABLED" then
        hzFrosty.Info.OutOfCombat = GetTime()
    end


end


-------------------------------------------------
--
-- hzFrosty.OnUpdate
--
-------------------------------------------------
function hzFrosty.OnUpdate()
    
    hzFrosty.Refresh()
    
end

-------------------------------------------------
--
-- hzFrosty.Refresh
--
-------------------------------------------------
function hzFrosty.Refresh()

    if not hzFrostyData.Enabled or not hzFrosty.Info.IsMage then
        HZFrostyBox:Hide()
        return
    end
    
    HZFrostyBox:Show()
       
    if not hzFrostyData.Locked then
        
        HZFrostyBoxBackground:Show()
        HZFrostyBoxText:Show()
        HZFrostyBox:EnableMouse( true )
        
        hzFrosty.ReshuffleBars( true )

        hzFrosty.SetBarInfo( "HZFrostyLifetimeBar",  "Bar 1", 45,  1 )
        hzFrosty.SetBarInfo( "HZFrostyWaterboltBar", "Bar 2", 2.5, 1 )
        hzFrosty.SetBarInfo( "HZFrostyFreezeBar",    "Bar 3", 90,  1 )
        
        HZFrostyLifetimeBar:Show()
        HZFrostyWaterboltBar:Show()
        HZFrostyFreezeBar:Show()
  
        return
    end

    HZFrostyBoxBackground:Hide()
    HZFrostyBoxText:Hide()
    HZFrostyBox:EnableMouse( false )

    hzFrosty.ReshuffleBars()

    --
    -- *** LIFETIME / COOLDOWN BARS ***
    --
    if hzFrostyData.ShowLifetime then
        if hzFrosty.Info.Summoned then
            local timeAlive = GetTime() - hzFrosty.Info.SummonedAt
            if type(timeAlive) ~= "number" or timeAlive > 45 or timeAlive < 0 then
                timeAlive = 45
            end
            local percAlive = timeAlive / 45
            hzFrosty.SetBarInfo( "HZFrostyLifetimeBar", HZFROSTY_LABEL_BAR1, 45 - timeAlive, percAlive )
            HZFrostyLifetimeBarStatusBar:SetStatusBarColor( 0.41, 0.80, 0.94 )
            HZFrostyLifetimeBar:Show()
        else
            HZFrostyLifetimeBar:Hide()
        end
    else
        HZFrostyLifetimeBar:Hide()
    end

    if hzFrostyData.ShowCooldown then
        if not hzFrosty.Info.Summoned and hzFrosty.Info.SummonedAt then
            
            local start, duration = GetSpellCooldown( HZFROSTY_SUMMON_SPELL )
            
            if start > 0 and duration > 30 then
                local timeAlive = GetTime() - start
                
                local percAlive = timeAlive / duration
                
                hzFrosty.SetBarInfo( "HZFrostyLifetimeBar", HZFROSTY_LABEL_BAR2, duration - timeAlive, percAlive )
                HZFrostyLifetimeBarStatusBar:SetStatusBarColor( 1.0, 0.5, 0.0 )
                HZFrostyLifetimeBar:Show()
            end
        
        end
    end
    
    --
    -- *** WATERBOLT BAR ***
    --    
    if hzFrostyData.ShowWaterbolt then
        if hzFrosty.Info.Summoned and hzFrosty.Info.Casting and ((GetTime()-hzFrosty.Info.CastingTo)<0.2) then
            local timeIn = GetTime() - hzFrosty.Info.CastingFrom
            if type(timeIn) ~= "number" or timeIn > 2.5 or timeIn < 0 then
                timeIn = 2.5
            end
            local percIn = timeIn / 2.5
            hzFrosty.SetBarInfo( "HZFrostyWaterboltBar", HZFROSTY_LABEL_BAR3, 2.5 - timeIn, percIn )
            HZFrostyWaterboltBar:Show()        
        else
            HZFrostyWaterboltBar:Hide()
        end
    else
        HZFrostyWaterboltBar:Hide()
    end
    
    --
    -- *** FROSTBOLT BAR ***
    --
    if hzFrostyData.ShowFreeze and hzFrosty.Info.Summoned then
       
        local index = 0
        for i=1,10 do if GetPetActionInfo(i) == HZFROSTY_SUMMON_AOE or GetPetActionInfo(i) == HZFROSTY_SUMMON_AOE2 then index = i; end end
        
        if index > 0 then
            local start, duration, enable = GetPetActionCooldown(index)
            if start > 0 and duration > 3 then
                local timeAlive = GetTime() - start
                
                local percAlive = timeAlive / duration
                
                hzFrosty.SetBarInfo( "HZFrostyFreezeBar", HZFROSTY_LABEL_BAR4, duration - timeAlive, percAlive )
                local timeLeft = duration - timeAlive
                local timeSummonLeft = 45 - (GetTime() - hzFrosty.Info.SummonedAt)
                if timeSummonLeft > timeLeft then
	            HZFrostyFreezeBarStatusBar:SetStatusBarColor( 0.41, 0.80, 0.94 )
                else
	            HZFrostyFreezeBarStatusBar:SetStatusBarColor( 1.0,  0.0, 0.0 )
                end
                HZFrostyFreezeBar:Show()
            else
                HZFrostyFreezeBar:Hide()
            end  
        else
            HZFrostyFreezeBar:Hide()
        end
    else
        HZFrostyFreezeBar:Hide()
    end
    
    
    
end


-------------------------------------------------
--
-- hzFrosty.SetBarInfo
--
-------------------------------------------------
function hzFrosty.SetBarInfo( barName, text, timeText, value )

    local barText = getglobal( barName.."StatusBarText" )
    local barTime = getglobal( barName.."StatusBarTime" )
    local barStatus = getglobal( barName.."StatusBar" )
    local barSpark = getglobal( barName.."StatusBarSpark" )
    
    --
    -- Main Text
    --
    barText:SetText( text )
    
    --
    -- Time Text
    --
    timeText = tonumber(timeText)
    if type(timeText) ~= "number" then timeText = 0; end
    if timeText < 60 then
        timeText = string.format("%.1f", timeText)
    else
        local timeMin = math.floor( timeText / 60 )
        local timeSec = math.fmod( timeText, 60 )
        timeText = timeMin..":"..string.format("%02.0f", timeSec)
    end
    barTime:SetText( timeText )

    --
    -- Bar Position
    --
    if type(value) ~= "number" or value < 0 or value > 1 then
        value = 1
    end
    barStatus:SetValue( value * 1000 )

    --
    -- Spark Position
    --    
    local width = barStatus:GetWidth()
    local sparkPosition = value * width
    if sparkPosition < 0 then sparkPosition = 0; end
    if sparkPosition > width then sparkPosition = width; end
    barSpark:ClearAllPoints()
    barSpark:SetPoint( "CENTER", barName.."StatusBar", "LEFT", sparkPosition, 0 )
   
end


-------------------------------------------------
--
-- hzFrosty.ReshuffleBars
--
-------------------------------------------------
function hzFrosty.ReshuffleBars( forceAll )

    local currentY = -20
    
    HZFrostyLifetimeBar:ClearAllPoints()
    HZFrostyWaterboltBar:ClearAllPoints()
    HZFrostyFreezeBar:ClearAllPoints()
    
    if forceAll or hzFrostyData.ShowLifetime or hzFrostyData.ShowCooldown then
        HZFrostyLifetimeBar:SetPoint( "TOP", "HZFrostyBox", "TOP", 0, currentY )
        currentY = currentY - 20
    end
    if forceAll or hzFrostyData.ShowWaterbolt then
        HZFrostyWaterboltBar:SetPoint( "TOP", "HZFrostyBox", "TOP", 0, currentY )
        currentY = currentY - 20
    end
    if forceAll or hzFrostyData.ShowFreeze then
        HZFrostyFreezeBar:SetPoint( "TOP", "HZFrostyBox", "TOP", 0, currentY )
        currentY = currentY - 20
    end
    
end



















-------------------------------------------------
--
-- hzFrosty.SlashHandler
--
-------------------------------------------------
function hzFrosty.SlashHandler( msg )

    if not hzFrosty.Info.IsMage then
        hzFrosty.Print( HZFROSTY_MSG_ONLYMAGES )
        return
    end
    
    local command = string.match( msg, "(%a+)" )
    local options  = string.match( msg, "%a+%s(.+)" )
    
    -- Output the default info
    if not command then
        hzFrosty.ShowUsage()
        return
    end
    
    
    -- Check the slash table
    command = string.lower( command ) 
    for k, v in pairs(HZFROSTY_SLASH_TABLE) do
        if command == k then
            if type(v) == "function" then
                v(options)
            end
        end
    end
  
end




-------------------------------------------------
--
-- hzFrosty.ShowUsage
--
-------------------------------------------------
function hzFrosty.ShowUsage()

    hzFrosty.Print( HZFROSTY_USAGE..": /frosty ["..HZFROSTY_OPTION1.."]" )
    hzFrosty.Print( "  "..HZFROSTY_OPTION2.." = "..HZFROSTY_OPT_ON.." | "..HZFROSTY_OPT_OFF.." | "..HZFROSTY_OPT_BARS.." | "..HZFROSTY_OPT_INFO.." | "..HZFROSTY_OPT_STATS.." | "..HZFROSTY_OPT_RESET )
    hzFrosty.Print( "  "..HZFROSTY_OPTION2.." = "..HZFROSTY_OPT_LIFETIME.." | "..HZFROSTY_OPT_COOLDOWN.." | "..HZFROSTY_OPT_CAST.." | "..HZFROSTY_OPT_FREEZE )

end



-------------------------------------------------
--
-- hzFrosty.LockBars
--
-------------------------------------------------
function hzFrosty.ShowInfo()

    hzFrosty.Print( HZFROSTY_MSG_INFO.." (v"..hzFrosty.Version..")" )
    hzFrosty.Print( "Author : Cubensis <Horizons> @ EU-Genjuros" )
    hzFrosty.Print( "|cffCFCFCF  German Localization : Toady @ EU-Rajaxx|r" )
    hzFrosty.Print( "|cffCFCFCF  German Localization : Frostbringer @ EU-Dentarg|r" )
    hzFrosty.Print( "  "..HZFROSTY_MSG_STATUS.." : "..hzFrosty.EnabledText( hzFrostyData.Enabled ) )
    if hzFrostyData.Enabled then
        hzFrosty.Print( "  "..HZFROSTY_MSG_BARLOCK.." : "..hzFrosty.EnabledText( hzFrostyData.Locked ) )
        hzFrosty.Print( "    "..HZFROSTY_MSG_SHOWLIFETIME.." : "..hzFrosty.EnabledText( hzFrostyData.ShowLifetime ) )
        hzFrosty.Print( "    "..HZFROSTY_MSG_SHOWCOOLDOWN.." : "..hzFrosty.EnabledText( hzFrostyData.ShowCooldown ) )
        hzFrosty.Print( "    "..HZFROSTY_MSG_SHOWWATERBOLT.." : "..hzFrosty.EnabledText( hzFrostyData.ShowWaterbolt ) )
        hzFrosty.Print( "    "..HZFROSTY_MSG_SHOWFREEZE.." : "..hzFrosty.EnabledText( hzFrostyData.ShowFreeze ) )
    end

end

-------------------------------------------------
--
-- hzFrosty.EnableAddon
--
-------------------------------------------------
function hzFrosty.EnableAddon( options )

    local turnOff = false

    if options == nil then options = ""; end
    options = string.lower(options)

    if options == HZFROSTY_OPT_OFF or options == HZFROSTY_OPT_OFF2 then 
        turnOff = true
    elseif options == HZFROSTY_OPT_ON or options == HZFROSTY_OPT_ON2 then
        turnOff = false
    elseif hzFrostyData.Enabled then          
        turnOff = true
    end
    
    if turnOff then
        hzFrostyData.Enabled = false
        hzFrosty.Print( HZFROSTY_MSG_STATUS.." : "..hzFrosty.EnabledText( hzFrostyData.Enabled ) )
    else
        hzFrostyData.Enabled = true
        hzFrosty.Print( HZFROSTY_MSG_STATUS.." : "..hzFrosty.EnabledText( hzFrostyData.Enabled ) )
    end
    
end


-------------------------------------------------
--
-- hzFrosty.LockBars
--
-------------------------------------------------
function hzFrosty.LockBars( options )

    local turnOff = false

    if options == nil then options = ""; end
    options = string.lower(options)

    if options == HZFROSTY_OPT_OFF or options == HZFROSTY_OPT_OFF2 then 
        turnOff = true
    elseif options == HZFROSTY_OPT_ON or options == HZFROSTY_OPT_ON2 then
        turnOff = false
    elseif hzFrostyData.Locked then          
        turnOff = true
    end
    
    if turnOff then
        hzFrostyData.Locked = false
        hzFrosty.Print( HZFROSTY_MSG_BARLOCK.." : "..hzFrosty.EnabledText( hzFrostyData.Locked ) )
    else
        hzFrostyData.Locked = true
        hzFrosty.Print( HZFROSTY_MSG_BARLOCK.." : "..hzFrosty.EnabledText( hzFrostyData.Locked ) )
    end
    
end


-------------------------------------------------
--
-- hzFrosty.HandleReset
--
-------------------------------------------------
function hzFrosty.HandleReset()

    -- TODO: Add YES/NO popup
    hzFrosty.DoReset()
    
end


-------------------------------------------------
--
-- hzFrosty.DoReset
--
-------------------------------------------------
function hzFrosty.DoReset()

    hzFrostyData = hzFrostyDefaults
    hzFrosty.Print( HZFROSTY_MSG_RESETCONFIG )  

end

-------------------------------------------------
--
-- hzFrosty.HandleLifetime
--
-------------------------------------------------
function hzFrosty.HandleLifetime( options )

    if type(options) ~= "string" then options = ""; end
    options = string.lower(string.trim(options))
    
    local output = true
    
    if options == HZFROSTY_OPT_TOGGLE then
        if hzFrostyData.ShowLifetime then
            hzFrostyData.ShowLifetime = false
        else
            hzFrostyData.ShowLifetime = true
        end
    elseif options == HZFROSTY_OPT_ON or options == HZFROSTY_OPT_ON2 then
        hzFrostyData.ShowLifetime = true
    elseif options == HZFROSTY_OPT_OFF or options == HZFROSTY_OPT_OFF2 then
        hzFrostyData.ShowLifetime = false
    else
        hzFrosty.Print( HZFROSTY_USAGE..": /frosty "..HZFROSTY_OPT_LIFETIME.." ["..HZFROSTY_OPTION1.."]" )
        hzFrosty.Print( "  "..HZFROSTY_MSG_USAGE )
        hzFrosty.Print( "  "..HZFROSTY_CURRENT.." : "..hzFrosty.EnabledText( hzFrostyData.ShowLifetime  ) )
        output = false
    end
    
    if output then
        hzFrosty.Print( HZFROSTY_MSG_SHOWLIFETIME.." : "..hzFrosty.EnabledText( hzFrostyData.ShowLifetime  ) )
    end
    
end


-------------------------------------------------
--
-- hzFrosty.HandleCooldown
--
-------------------------------------------------
function hzFrosty.HandleCooldown( options )

    if type(options) ~= "string" then options = ""; end
    options = string.lower(string.trim(options))
    
    local output = true
    
    if options == HZFROSTY_OPT_TOGGLE then
        if hzFrostyData.ShowCooldown then
            hzFrostyData.ShowCooldown = false
        else
            hzFrostyData.ShowCooldown = true
        end
    elseif options == HZFROSTY_OPT_ON or options == HZFROSTY_OPT_ON2 then
        hzFrostyData.ShowCooldown = true
    elseif options == HZFROSTY_OPT_OFF or options == HZFROSTY_OPT_OFF2 then
        hzFrostyData.ShowCooldown = false
    else
        hzFrosty.Print( HZFROSTY_USAGE..": /frosty "..HZFROSTY_OPT_COOLDOWN.." ["..HZFROSTY_OPTION1.."]" )
        hzFrosty.Print( "  "..HZFROSTY_MSG_USAGE )
        hzFrosty.Print( "  "..HZFROSTY_CURRENT.." : "..hzFrosty.EnabledText( hzFrostyData.ShowCooldown  ) )
        output = false
    end
    
    if output then
        hzFrosty.Print( HZFROSTY_MSG_SHOWCOOLDOWN.." : "..hzFrosty.EnabledText( hzFrostyData.ShowCooldown  ) )
    end    
end

-------------------------------------------------
--
-- hzFrosty.HandleWaterbolt
--
-------------------------------------------------
function hzFrosty.HandleWaterbolt( options )

    if type(options) ~= "string" then options = ""; end
    options = string.lower(string.trim(options))
    
    local output = true
    
    if options == HZFROSTY_OPT_TOGGLE then
        if hzFrostyData.ShowWaterbolt then
            hzFrostyData.ShowWaterbolt = false
        else
            hzFrostyData.ShowWaterbolt = true
        end
    elseif options == HZFROSTY_OPT_ON or options == HZFROSTY_OPT_ON2 then
        hzFrostyData.ShowWaterbolt = true
    elseif options == HZFROSTY_OPT_OFF or options == HZFROSTY_OPT_OFF2 then
        hzFrostyData.ShowWaterbolt = false
    else
        hzFrosty.Print( HZFROSTY_USAGE..": /frosty "..HZFROSTY_OPT_CAST.." ["..HZFROSTY_OPTION1.."]" )
        hzFrosty.Print( "  "..HZFROSTY_MSG_USAGE )
        hzFrosty.Print( "  "..HZFROSTY_CURRENT.." : "..hzFrosty.EnabledText( hzFrostyData.ShowWaterbolt ) )
        output = false
    end
    
    if output then
        hzFrosty.Print( HZFROSTY_MSG_SHOWWATERBOLT.." : "..hzFrosty.EnabledText( hzFrostyData.ShowWaterbolt  ) )
    end    

end

-------------------------------------------------
--
-- hzFrosty.HandleFreeze
--
-------------------------------------------------
function hzFrosty.HandleFreeze( options )

    if type(options) ~= "string" then options = ""; end
    options = string.lower(string.trim(options))
    
    local output = true
    
    if options == HZFROSTY_OPT_TOGGLE then
        if hzFrostyData.ShowFreeze then
            hzFrostyData.ShowFreeze = false
        else
            hzFrostyData.ShowFreeze = true
        end
    elseif options == HZFROSTY_OPT_ON or options == HZFROSTY_OPT_ON2 then
        hzFrostyData.ShowFreeze = true
    elseif options == HZFROSTY_OPT_OFF or options == HZFROSTY_OPT_OFF2 then
        hzFrostyData.ShowFreeze = false
    else
        hzFrosty.Print( HZFROSTY_USAGE..": /frosty "..HZFROSTY_OPT_FREEZE.." ["..HZFROSTY_OPTION1.."]" )
        hzFrosty.Print( "  "..HZFROSTY_MSG_USAGE )
        hzFrosty.Print( "  "..HZFROSTY_CURRENT.." : "..hzFrosty.EnabledText( hzFrostyData.ShowFreeze  ) )
        output = false
    end
    
    if output then
        hzFrosty.Print( HZFROSTY_MSG_SHOWFREEZE.." : "..hzFrosty.EnabledText( hzFrostyData.ShowFreeze  ) )
    end
    
end



-------------------------------------------------
--
-- hzFrosty.HandleStats
--
-------------------------------------------------
function hzFrosty.HandleStats( options )

    if type(options) ~= "string" then options = ""; end
    options = string.lower(string.trim(options))

    if options == "" or options == HZFROSTY_OPT_SHOW then

        hzFrosty.Print( HZFROSTY_MSG_STATS )

	    local lifedps = 0
	    local sessiondps = 0
	    local combatdps = 0

        if hzFrostyData.Stats.LifetimeDuration > 0 then
            lifedps = string.format( "%.1f", hzFrostyData.Stats.LifetimeDamage / hzFrostyData.Stats.LifetimeDuration )
        end
        if hzFrostyData.Stats.SessionDuration > 0 then
            sessiondps = string.format( "%.1f", hzFrostyData.Stats.SessionDamage / hzFrostyData.Stats.SessionDuration )
        end
        if hzFrostyData.Stats.CombatDuration > 0 then
            lifedps = string.format( "%.1f", hzFrostyData.Stats.CombatDamage / hzFrostyData.Stats.CombatDuration )
        end

        hzFrosty.Print( "  "..HZFROSTY_MSG_STATS_1.." : |cffFFFF00"..hzFrostyData.Stats.LifetimeDamage.."|r "..HZFROSTY_MSG_STATS_IN.." |cff00FF00"..hzFrostyData.Stats.LifetimeCount.."|r (|cffFF6060"..lifedps.." DPS|r)" )
        hzFrosty.Print( "  "..HZFROSTY_MSG_STATS_2.." : |cffFFFF00"..hzFrostyData.Stats.SessionDamage.."|r "..HZFROSTY_MSG_STATS_IN.." |cff00FF00"..hzFrostyData.Stats.SessionCount.."|r (|cffFF6060"..sessiondps.." DPS|r)" )
        hzFrosty.Print( "  "..HZFROSTY_MSG_STATS_3.." : |cffFFFF00"..hzFrostyData.Stats.CombatDamage.."|r "..HZFROSTY_MSG_STATS_IN.." |cff00FF00"..hzFrostyData.Stats.CombatCount.."|r (|cffFF6060"..combatdps.." DPS|r)" )

  	

    elseif options == HZFROSTY_OPT_RESET then

        hzFrostyData.Stats.SessionDamage    = 0
        hzFrostyData.Stats.SessionCount     = 0
        hzFrostyData.Stats.SessionDuration  = 0
        hzFrosty.Print( HZFROSTY_MSG_STATS_RESET )

    elseif options == HZFROSTY_OPT_RESETALL then

        hzFrostyData.Stats.LifetimeDamage   = 0
        hzFrostyData.Stats.LifetimeCount    = 0
        hzFrostyData.Stats.LifetimeDuration = 0
        hzFrostyData.Stats.SessionDamage    = 0
        hzFrostyData.Stats.SessionCount     = 0
        hzFrostyData.Stats.SessionDuration  = 0
        hzFrosty.Print( HZFROSTY_MSG_STATS_RESETALL )

    else

        hzFrosty.Print( HZFROSTY_USAGE..": /frosty "..HZFROSTY_OPT_STATS.." ["..HZFROSTY_OPTION1.."]" )
        hzFrosty.Print( "  "..HZFROSTY_OPTION2.." : "..HZFROSTY_OPT_SHOW.." | "..HZFROSTY_OPT_RESET.." | "..HZFROSTY_OPT_RESETALL )

    end
    
end


-------------------------------------------------
--
-- hzFrosty.HandlePetDamageEvent
--
-------------------------------------------------
function hzFrosty.HandlePetDamageEvent( msg )

    local retValid, retDamage

    local damage = string.match( msg, HZFROSTY_PATTERN_DMG )

    --
    -- return clean types
    --

    if not damage or damage == 0 then
        return false, 0
    end

    damage = tonumber(damage)  
    if not damage then damage = 0; end
    return true, damage

end


-------------------------------------------------
--
-- hzFrosty.EnabledText
--
-------------------------------------------------
function hzFrosty.EnabledText( bool )

    if bool then
        return "[|cff00FF00"..HZFROSTY_MSG_ON.."|r]"
    end
    return "[|cffFF0000"..HZFROSTY_MSG_OFF.."|r]"

end


-------------------------------------------------
--
-- HZFROSTY_SLASH_TABLE
--
-------------------------------------------------
HZFROSTY_SLASH_TABLE = { [HZFROSTY_OPT_INFO]       = hzFrosty.ShowInfo,

                         [HZFROSTY_OPT_ON]         = function() hzFrosty.EnableAddon( "on" ); end,
                         [HZFROSTY_OPT_ON2]        = function() hzFrosty.EnableAddon( "on" ); end,
                         [HZFROSTY_OPT_OFF]        = function() hzFrosty.EnableAddon( "off" ); end,
                         [HZFROSTY_OPT_OFF2]       = function() hzFrosty.EnableAddon( "off" ); end,
                         
                         [HZFROSTY_OPT_BARS]       = hzFrosty.LockBars,
                         [HZFROSTY_OPT_LOCK]       = function() hzFrosty.LockBars( "on" ); end,
                         [HZFROSTY_OPT_UNLOCK]     = function() hzFrosty.LockBars( "off" ); end,
                         [HZFROSTY_OPT_MOVE]       = function() hzFrosty.LockBars( "off" ); end,
                         
                         [HZFROSTY_OPT_LIFETIME]   = hzFrosty.HandleLifetime,
                         [HZFROSTY_OPT_COOLDOWN]   = hzFrosty.HandleCooldown,
                         [HZFROSTY_OPT_WATERBOLT]  = hzFrosty.HandleWaterbolt,
                         [HZFROSTY_OPT_CAST]       = hzFrosty.HandleWaterbolt,
                         [HZFROSTY_OPT_FREEZE]     = hzFrosty.HandleFreeze,
                         [HZFROSTY_OPT_FROSTNOVA]  = hzFrosty.HandleFreeze,
                         [HZFROSTY_OPT_NOVA]       = hzFrosty.HandleFreeze,
                         
                         [HZFROSTY_OPT_STATS]      = hzFrosty.HandleStats,
                         
                         [HZFROSTY_OPT_RESET]      = hzFrosty.HandleReset,
                          }

